%define modname easyvpn

Summary: Issabel EasyVPN
Name:    issabel-%{modname}
Version: 4.0.0
Release: 2
License: GPL
Group:   Applications/System
Source0: %{modname}_%{version}-%{release}.tgz
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildArch: noarch
Requires: issabel-framework >= 4.0.0-0
Requires: issabel-system
Requires: easy-rsa
Requires: expect
Requires: openvpn

%description
Issabel EasyVPN. Module for configuring OpenVPN. Based on the module by Enlaza.mx (info@enlaza.mx). 

%prep
%setup -n %{name}

%install
rm -rf $RPM_BUILD_ROOT

# Files provided by all Issabel modules
mkdir -p    $RPM_BUILD_ROOT%{_localstatedir}/www/html
mkdir -p    $RPM_BUILD_ROOT%{_datadir}/issabel/privileged
mkdir -p    $RPM_BUILD_ROOT%{_datadir}/easy-rsa/2.0

mv ovpn2/openvpn-wrapper.php             $RPM_BUILD_ROOT%{_localstatedir}/www/html/
mv ovpn2                                 $RPM_BUILD_ROOT%{_localstatedir}/www/html/
mv setup/usr/share/issabel/privileged/*  $RPM_BUILD_ROOT%{_datadir}/issabel/privileged
mv setup/usr/share/easy-rsa/2.0/*        $RPM_BUILD_ROOT%{_datadir}/easy-rsa/2.0

rmdir setup/usr/share/issabel/privileged
rmdir setup/usr/share/easy-rsa/2.0

rmdir setup/usr/share/issabel setup/usr/share/easy-rsa setup/usr/share setup/usr

# The following folder should contain all the data that is required by the installer,
# that cannot be handled by RPM.
mkdir -p    $RPM_BUILD_ROOT%{_datadir}/issabel/module_installer/%{name}-%{version}-%{release}/
mv setup/   $RPM_BUILD_ROOT%{_datadir}/issabel/module_installer/%{name}-%{version}-%{release}/
mv menu.xml $RPM_BUILD_ROOT%{_datadir}/issabel/module_installer/%{name}-%{version}-%{release}/

%pre
mkdir -p %{_datadir}/issabel/module_installer/%{name}-%{version}-%{release}/
touch %{_datadir}/issabel/module_installer/%{name}-%{version}-%{release}/preversion_%{modname}.info
if [ $1 -eq 2 ]; then
    rpm -q --queryformat='%{VERSION}-%{RELEASE}' %{name} > %{_datadir}/issabel/module_installer/%{name}-%{version}-%{release}/preversion_%{modname}.info
fi

%post

pathModule="%{_datadir}/issabel/module_installer/%{name}-%{version}-%{release}"

# Run installer script to fix up ACLs and add module to Issabel menus.
issabel-menumerge $pathModule/menu.xml
#pathSQLiteDB="%{_localstatedir}/www/db"
#mkdir -p $pathSQLiteDB
preversion=`cat $pathModule/preversion_%{modname}.info`
rm $pathModule/preversion_%{modname}.info

if [ $1 -eq 1 ]; then #install
    # The installer database
    #issabel-dbprocess "install" "$pathModule/setup/db"

    mkdir /etc/openvpn/clientkeys
    mkdir /usr/share/easy-rsa/2.0/keys
    #mv /var/www/html/ovpn2/openvpn-wrapper.php /var/www/html/
    #mv /var/www/html/ovpn2/scripts/* /usr/share/easy-rsa/2.0/
    #cd /var/www/html/ovpn2/misc/elfinder-connector
    chown -R asterisk.asterisk /etc/openvpn
    chown -R asterisk.asterisk /usr/share/easy-rsa/
    service httpd reload
    systemctl -f enable openvpn@server.service
    sed -i 's/md5/sha256/g' /usr/share/easy-rsa/2.0/openssl-0.9.6.cnf
    sed -i 's/md5/sha256/g' /usr/share/easy-rsa/2.0/openssl-0.9.8.cnf
    sed -i 's/md5/sha256/g' /usr/share/easy-rsa/2.0/openssl-1.0.0.cnf

elif [ $1 -eq 2 ]; then #update
    # The update database
    #$pathModule/setup/checkFields "$preversion" "$pathModule"
    #issabel-dbprocess "update"  "$pathModule/setup/db" "$preversion"
    #$pathModule/setup/updateDatabase "$preversion"
    mv /var/www/html/ovpn2/scripts/* /usr/share/easy-rsa/2.0/
fi

%clean
rm -rf $RPM_BUILD_ROOT

%preun
pathModule="%{_datadir}/issabel/module_installer/%{name}-%{version}-%{release}"

if [ $1 -eq 0 ] ; then # Validation for desinstall this rpm
  echo "Delete Security menus"
  issabel-menuremove "%{modname}"

  echo "Dump and delete %{name} databases"
  issabel-dbprocess "delete" "$pathModule/setup/db"

  #rm -rf /var/www/html/ovpn2
  rm -rf /etc/openvpn/*
 
fi

%files
%defattr(-, root, root)
%{_localstatedir}/www/html/*
%{_datadir}/issabel/module_installer/*
%defattr(644, root, root)
%defattr(0755, root, root)
%{_datadir}/issabel/privileged/*
%{_datadir}/easy-rsa/2.0/build-yealink
%{_datadir}/easy-rsa/2.0/cca.sh
%{_datadir}/easy-rsa/2.0/clean.sh
%{_datadir}/easy-rsa/2.0/createca.exp
%{_datadir}/easy-rsa/2.0/createclient.exp
%{_datadir}/easy-rsa/2.0/createserver.exp
%{_datadir}/easy-rsa/2.0/createyealink.exp
%{_datadir}/easy-rsa/2.0/csrv.sh
%{_datadir}/easy-rsa/2.0/elinclient.sh
%{_datadir}/easy-rsa/2.0/ewinclient.sh
%{_datadir}/easy-rsa/2.0/linclient.sh
%{_datadir}/easy-rsa/2.0/openssl-yealink.cnf
%{_datadir}/easy-rsa/2.0/pkitoolyealink
%{_datadir}/easy-rsa/2.0/revoke.sh
%{_datadir}/easy-rsa/2.0/snomclient.sh
%{_datadir}/easy-rsa/2.0/winclient.sh
%{_datadir}/easy-rsa/2.0/yeaclient2.sh
%{_datadir}/easy-rsa/2.0/yeaclient.sh

%{_datadir}/easy-rsa/2.0/build-inter
%{_datadir}/easy-rsa/2.0/build-req
%{_datadir}/easy-rsa/2.0/openssl-0.9.6.cnf
%{_datadir}/easy-rsa/2.0/sign-req
%{_datadir}/easy-rsa/2.0/build-key
%{_datadir}/easy-rsa/2.0/build-req-pass
%{_datadir}/easy-rsa/2.0/openssl-0.9.8.cnf
%{_datadir}/easy-rsa/2.0/vars
%{_datadir}/easy-rsa/2.0/build-key-pass
%{_datadir}/easy-rsa/2.0/clean-all
%{_datadir}/easy-rsa/2.0/openssl-1.0.0.cnf
%{_datadir}/easy-rsa/2.0/whichopensslcnf
%{_datadir}/easy-rsa/2.0/revoke.sh
%{_datadir}/easy-rsa/2.0/build-ca
%{_datadir}/easy-rsa/2.0/build-key-pkcs12
%{_datadir}/easy-rsa/2.0/inherit-inter
%{_datadir}/easy-rsa/2.0/pkitool
%{_datadir}/easy-rsa/2.0/build-dh
%{_datadir}/easy-rsa/2.0/build-key-server
%{_datadir}/easy-rsa/2.0/list-crl
%{_datadir}/easy-rsa/2.0/revoke-full



%changelog
* Tue Feb 06 2018 Nicolas Gudino <nicolas@issabel.com> - 4.0.0-2
- Addition of easy-rsa 2.2 scripts

* Wed Jul 12 2017 Nicolas Gudino <nicolas@issabel.com> - 4.0.0-1
- Initial Issabel build, forked from Elastix Easyvpn



